Fisherman fisherman = new Fisherman(1000,800);
Line line = new Line(1000,800);
//Fish fish = new Fish(1000,800);
ArrayList<Fish> fishList;
//Shark shark = new Shark(1000,800);
ArrayList<Shark> sharkList;
int score;
int state = 0;
PImage img;
PImage img2;
Timer startTimer;


void setup(){
    size(1000,800);
    fishList = new ArrayList<Fish>();
    sharkList = new ArrayList<Shark>();
    img = loadImage("underwaterScene.jpg");
    img2 = loadImage("gameOverShark.png");
    startTimer = new Timer(60);

}

void draw(){
    if(state == 0){
    startCover();
}else
    if(state == 1){
    game();
}else
    if(state == 2){
    gameOver();
}else if(state == 3){
    timeUp();
}
}
    
void startCover(){ //state 0
    background(125,125,125);
    image(img,0,0);
    fill(255);
    textSize(70);
    text("WELCOME TO FISHING", 150,200);
    text("PRESS 'G' TO START", 150, 400);
}
    
void game(){ //state 1    

    background(125,125,125);
    image(img, 0,0);
    
    textSize(50);
    fill(50,50,50);
    text(score,700, 60);
    fisherman.display();
    line.display();
    //shark.display();
    //fish.display();
    startTimer.countDown();
    fill(50,50,50);
    text(startTimer.getTime(), 50,50);
    
    
    if(fishList.size()<20){
        fishList.add(new Fish(width,height));
    if(sharkList.size()<5){
        sharkList.add(new Shark(width,height));
    }
    }  
    
    for(int i =fishList.size()-1; i>0; i--){
        Fish fish = fishList.get(i);
        fish.display();
        
        if(line.collideFish(fish)){
            print("fish got hit");
            line.velY = -1;
            fish.posX = line.posX; 
            fish.posY = line.posY;    
        }
        
        if(fisherman.collideFish(fish)){
            print("cathed");
            line.velY = 0;
            fishList.remove(i);
            score = score + 1;   
        }
           
        if(fish.isOutOfWindow()){
            fishList.remove(i);
        }
    }
    
    for(int i =sharkList.size()-1; i>0; i--){
        Shark shark = sharkList.get(i);
        shark.display();
        
        if(line.collideShark(shark)){
            print("shark got hit");
            line.velY = -10;
            shark.posX = line.posX; 
            shark.posY = line.posY;
        }
        if(fisherman.collideShark(shark)){
            print("GAME OVER");
            line.velY = 0; 
            state = 2;
        }
        if(shark.isOutOfWindow()){
            sharkList.remove(i);
        }
    }
    if(startTimer.time < 0){  
        state = 3;}
}

void timeUp(){ //state 3
    background(125,125,125);
    text("Time's up!", 150, 200);
    text("Your score:", 150, 300);
    text(score, 450,300);
    text("Press 'T' to try again", 150, 400);    
}

void gameOver(){//state 2
    background(255,0,0);
    image(img2, 600, 100, 300,300);
    textSize(100);
    text("GAME OVER", 200,300);
    text("Press 'R' to restart", 80,500);
}

void fishRestart(){
fishList.clear();
 for(int i =0; i<10; i++){
    fishList.add(new Fish (width, height));
    }
    
sharkList.clear();
 for(int i =0; i<10; i++){
    sharkList.add(new Shark (width, height));
    }
    fisherman = new Fisherman(width, height);
}

void keyPressed(){
    fisherman.keyPressed();
    line.keyPressed();
    
    //State management.
    if(state==0 && key=='g'){
        state=1;}
    if(state== 2 && key== 'r'){
        state = 1;
        score = 0;
        startTimer = new Timer(60);
        fishRestart();
    }
    if(state==3 && key=='t'){
        state=1;
        score = 0;
        fishRestart();
        startTimer = new Timer(60);}
    }
